unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms,
  StdCtrls, Dialogs, Spin;

procedure changefile(mp3file:string);

type ID3TAG=record
     Title,Artist,Album,Genre,Year,Comment:shortstring;
     Track:integer;
     end;

     MpgInfo=record
     Version,Layer,ChannelMode,ChannelModeExt,Emphasis:shortstring;
     Duration,KBitRate,SamplingRate,FrameLen,Frames:integer;
     Sync,CRC,Copyright,Original:boolean;
     end;

function UpdateID3(mp3file,Title,Artist,Album,Year,Comment:shortstring;Track:integer):boolean;stdcall;external 'MP3Info.dll';
function ID3Get(mp3file:shortstring):ID3TAG;stdcall;external 'MP3Info.dll';
function Kill(mp3file:shortstring):boolean;stdcall;external 'MP3Info.dll';
function MpgGet(mp3file:shortstring):MpgInfo;stdcall;external 'MP3Info.dll';

type
  TForm1 = class(TForm)
    Button1: TButton;
    od: TOpenDialog;
    CmdUpdate: TButton;
    CmdKill: TButton;
    FilenameLab: TEdit;
    Label5: TLabel;
    GroupBox1: TGroupBox;
    Mpeg: TLabel;
    Layer: TLabel;
    ChannelMode: TLabel;
    ChannelModeExt: TLabel;
    Emphasis: TLabel;
    Duration: TLabel;
    FrameLen: TLabel;
    SamplingRate: TLabel;
    Other: TLabel;
    KBitRate: TLabel;
    Frames: TLabel;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Track: TLabel;
    edArtist: TEdit;
    edTitle: TEdit;
    edAlbum: TEdit;
    edGenre: TEdit;
    edYear: TEdit;
    edComment: TEdit;
    edTrack: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure CmdUpdateClick(Sender: TObject);
    procedure CmdKillClick(Sender: TObject);
    procedure FilenameLabChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    end;
var
  Form1: TForm1;
  n:string;


implementation

{$R *.DFM}
procedure changefile(mp3file:string);
var a:id3tag;
    b:mpginfo;
begin
with form1 do
begin
  a:=ID3Get(mp3file);
  edTitle.text:=a.Title;
  edArtist.text:=a.artist;
  edAlbum.text:=a.album;
  edGenre.text:=a.genre;
  edYear.text:=a.Year;
  edTrack.value:=a.Track;
  edComment.text:=a.comment;
  b:=MpgGet(mp3file);
  Mpeg.caption:='Mpeg: '+b.Version;
  Layer.caption:='Layer: '+b.Layer;
  duration.Caption:='Duration: ';
  if (b.Duration div 3600000)>0 then duration.Caption:=duration.Caption+inttostr(b.Duration div 3600000)+':';
  if (((b.Duration mod 3600000) div 60000)<10) and ((b.Duration div 3600000)>0) then duration.Caption:=duration.Caption+'0';
  duration.Caption:=duration.Caption+inttostr((b.Duration mod 3600000) div 60000)+':';
  if ((b.Duration mod 3600000) mod 60000)div 1000<10 then duration.Caption:=duration.Caption+'0';
  duration.Caption:=duration.Caption+inttostr(((b.Duration mod 3600000) mod 60000)div 1000);
  ChannelMode.caption:='ChannelMode: '+b.ChannelMode;
  ChannelModeExt.caption:='ChannelModeExt: '+b.ChannelModeExt;
  Emphasis.caption:='Emphasis: '+b.Emphasis;
  Other.caption:='Sync:';
  if b.sync then Other.caption:=Other.caption+'Yes' else Other.caption:=Other.caption+'No';
  Other.caption:=Other.caption+', CRC:';
  if b.crc then Other.caption:=Other.caption+'Yes' else Other.caption:=Other.caption+'No';
  Other.caption:=Other.caption+', Copyright:';
  if b.Copyright then Other.caption:=Other.caption+'Yes' else Other.caption:=Other.caption+'No';
  Other.caption:=Other.caption+', Original:';
  if b.Original then Other.caption:=Other.caption+'Yes' else Other.caption:=Other.caption+'No';
  KBitRate.caption:='KBitRate: '+inttostr(b.KBitRate)+' KBps';
  SamplingRate.caption:='SamplingRate: '+inttostr(b.SamplingRate)+' Hz';
  FrameLen.caption:='FrameLen: '+inttostr(b.FrameLen);
  Frames.caption:='Frames: '+inttostr(b.Frames);

  cmdupdate.Enabled:=true;
  cmdkill.Enabled:=true;
  n:=mp3file;
  filenamelabchange(od);
end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
if od.execute then changefile(od.filename);
end;

procedure TForm1.CmdUpdateClick(Sender: TObject);
var resultat:boolean;
begin
resultat:=UpdateID3(od.filename,edTitle.Text,edArtist.Text,edAlbum.Text,edYear.Text,edComment.Text,edTrack.value);
if resultat=false then application.messagebox('Can''t write !!!','Error',IDOK);
end;

procedure TForm1.CmdKillClick(Sender: TObject);
var resultat:boolean;
begin
resultat:=Kill(od.filename);
if resultat=false then application.messagebox('Can''t write !!!','Error',IDOK);
end;

procedure TForm1.FilenameLabChange(Sender: TObject);
begin
FilenameLab.Text:=n;
end;

procedure TForm1.FormCreate(Sender: TObject);
var param:string;
    i:integer;
begin
  n:='';
  if paramcount>0 then
  begin
  for i:=1 to paramcount-1 do param:=param+paramstr(i)+' ';
  param:=param+paramstr(paramcount);
  if fileexists(param) then changefile(param);
  end;
end;

end.
